from scipy import integrate
import numpy as np
import math
#Input these four parameters, then Run this code.
#Example data from our Experiment 4 (2D, preset A).
alpha_x = 0.011054275
sigma_ax = 0.960581021
alpha_y = 0.018847576
sigma_ay = 0.914660675

#Increasing W from 0.1 to 16 mm (step: 0.1 mm) to compute the success rates.
#Because `range' can use only integers, here I write `0 to 160 (step: 1)' that means 0 to 16 mm (step: 0.1 mm).
for wStep in range(0, 160, 1):
    W = wStep * 0.1+0.1
    def func1(x, y):
        sigma_x = math.sqrt(alpha_x*W**2 + sigma_ax**2)
        sigma_y = math.sqrt(alpha_y*W**2 + sigma_ay**2)
        return math.exp(-(x**2)/(2*sigma_x**2) - y**2/(2*sigma_y**2)) / (2*math.pi*sigma_x*sigma_y)
 
    #Range of x is from -0.5*W to 0.5*W.
    #Because the target shape is circular, the range of y is from -sqrt((W/2)^2-x^2) to +sqrt((W/2)^2-x^2).
    res = integrate.dblquad(func1, -0.5*W, 0.5*W, lambda x: -math.sqrt((W/2)**2 - x**2), lambda x: math.sqrt((W/2)**2 - x**2))[0] * 100
    print("W = ", '{:.3g}'.format(W), " [mm], success rate = ", '{:.7g}'.format(res), "[%]")
    
    #Print only success rate data:
    #print('{:.7g}'.format(res))
 